// AddressBook.cpp : implementation file
//

#include "stdafx.h"
#include "SerAddressBook.h"
#include "AddressBook.h"


// CAddressBook

IMPLEMENT_SERIAL(CAddressBook, CObject, -1)

CAddressBook::CAddressBook() 
{
	m_uiFileVersion = 0;
}

CAddressBook::~CAddressBook()
{
}

// CAddressBook member functions
bool CAddressBook::AddContact(const Contact& contact)
{
	if(FindContact(contact.GetFirstName()) == NULL)
	{
		m_cContactsList.AddTail(contact);
		return true;
	}

	return false;
}

bool CAddressBook::RemoveContact(const CString& firstname, const CString& lastname)
{
	POSITION pos = m_cContactsList.GetHeadPosition();
	while(pos != NULL)
	{
		POSITION former = pos;
		Contact contact = m_cContactsList.GetNext(pos);
		if(contact.GetFirstName().Compare(firstname) == 0 &&
			contact.GetLastName().Compare(lastname) == 0)
		{
			m_cContactsList.RemoveAt(former);
			return true;
		}
	}

	return false;
}

POSITION CAddressBook::FindContact(const CString& firstname) const
{
	POSITION pos = m_cContactsList.GetHeadPosition();
	while(pos != NULL)
	{
		POSITION former = pos;
		Contact contact = m_cContactsList.GetNext(pos);

		if(contact.GetFirstName().Compare(firstname) == 0)
			return former;
	}

	return NULL;
}

bool CAddressBook::FindContact(const CString& firstname, Contact& contact) const
{
	POSITION pos = m_cContactsList.GetHeadPosition();
	while(pos != NULL)
	{
		contact = m_cContactsList.GetNext(pos);
		if(contact.GetFirstName().Compare(firstname) == 0)
		{
			return true;
		}
	}

	return false;
}

void CAddressBook::Serialize( CArchive& ar )
{
	ar.SerializeClass(RUNTIME_CLASS(CAddressBook));

	// storing
	if (ar.IsStoring())
	{
		ar << m_uiFileVersion;

		// write the number of contacts
		ar << (int)m_cContactsList.GetCount();
		Contact::SetCurrentFileVersion(m_uiFileVersion);

		// write all the contacts
		POSITION pos = m_cContactsList.GetHeadPosition();
		while(pos != NULL)
		{
			Contact contact = m_cContactsList.GetNext(pos);

			contact.Serialize(ar);
		}
	}
	// loading
	else
	{
		ar >> m_uiFileVersion;

		m_cContactsList.RemoveAll();

		int count = 0;
		ar >> count;

		// read the number of contacts
		for(INT_PTR i = 0; i < count; ++i)
		{
			Contact contact;
			contact.Serialize(ar);

			m_cContactsList.AddTail(contact);
		}
	}
}
