#pragma once

// CAddressBook command target
#include "Contact.h"

class CAddressBook : public CObject
{
	DECLARE_SERIAL(CAddressBook);

	ContactList m_cContactsList;

public:
	CAddressBook();
	virtual ~CAddressBook();

	void Serialize( CArchive& ar );

	bool AddContact(const Contact& contact);
	bool RemoveContact(const CString& firstname, const CString& lastname);
	POSITION FindContact(const CString& firstname) const;
	bool FindContact(const CString& firstname, Contact& contact) const;
	
	const ContactList& GetContacts() const {return m_cContactsList;}

	void	SetFileVersion(int nFV) {	m_uiFileVersion = nFV;	}
	int		GetFileVersion() { return m_uiFileVersion; }

private:
	int		m_uiFileVersion;
};


