// SerAddressBookDlg.cpp : implementation file
//

#include "stdafx.h"
#include "SerAddressBook.h"
#include "SerAddressBookDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CSerAddressBookDlg dialog

CSerAddressBookDlg::CSerAddressBookDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSerAddressBookDlg::IDD, pParent)
	, m_nContactVersion(0)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

	m_strFirstName	=	_T("");
	m_strLastName	=	_T("");
	m_strAddress	=	_T("");
	m_strPhone		=	_T("");
	m_strMobilePhone=	_T("");
	m_strEmail		=	_T("");
	m_strFilePath	=	_T("");
}

void CSerAddressBookDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Text(pDX, IDC_EDIT_FIRSTNAME, m_strFirstName);
	DDX_Text(pDX, IDC_EDIT_LASTNAME, m_strLastName);
	DDX_Text(pDX, IDC_EDIT_ADDRESS, m_strAddress);
	DDX_Text(pDX, IDC_EDIT_PHONE, m_strPhone);
	DDX_Text(pDX, IDC_EDIT_MOBILE_PHONE, m_strMobilePhone);
	DDX_Text(pDX, IDC_EDIT_EMAIL, m_strEmail);
	DDX_Control(pDX, IDC_LIST_ADRESS_BOOK, m_cList);
}

BEGIN_MESSAGE_MAP(CSerAddressBookDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_RADIO_VERSION_1, &CSerAddressBookDlg::OnBnClickedRadioVersion1)
	ON_BN_CLICKED(IDC_RADIO_VERSION_2, &CSerAddressBookDlg::OnBnClickedRadioVersion2)
	ON_BN_CLICKED(IDC_BTN_SAVE, &CSerAddressBookDlg::OnBnClickedBtnSave)
	ON_BN_CLICKED(IDC_BTN_LOAD, &CSerAddressBookDlg::OnBnClickedBtnLoad)
	ON_BN_CLICKED(IDC_BTN_ADD_DATA_TO_GRID, &CSerAddressBookDlg::OnBnClickedBtnAddDataToGrid)
	ON_BN_CLICKED(IDC_BTN_REMOVE_DATA_FROM_GRID, &CSerAddressBookDlg::OnBnClickedBtnRemoveDataFromGrid)
	ON_BN_CLICKED(IDC_BTN_CLEAN_THE_LIST, &CSerAddressBookDlg::OnBnClickedBtnCleanTheList)
	ON_BN_CLICKED(IDC_BTN_EXIT, &CSerAddressBookDlg::OnBnClickedBtnExit)
END_MESSAGE_MAP()


// CSerAddressBookDlg message handlers

BOOL CSerAddressBookDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	m_cList.SetExtendedStyle(LVS_EX_FULLROWSELECT|LVS_EX_GRIDLINES);

	((CButton*)GetDlgItem(IDC_RADIO_VERSION_1))->SetCheck(BST_CHECKED);
	OnBnClickedRadioVersion1();

	UpdateData(FALSE);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CSerAddressBookDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CSerAddressBookDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CSerAddressBookDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


void CSerAddressBookDlg::OnBnClickedRadioVersion1()
{
	GetDlgItem(IDC_EDIT_FIRSTNAME)->EnableWindow(TRUE);
	GetDlgItem(IDC_EDIT_LASTNAME)->EnableWindow(TRUE);
	GetDlgItem(IDC_EDIT_ADDRESS)->EnableWindow(TRUE);
	GetDlgItem(IDC_EDIT_PHONE)->EnableWindow(TRUE);
	GetDlgItem(IDC_EDIT_MOBILE_PHONE)->EnableWindow(FALSE);
	GetDlgItem(IDC_EDIT_EMAIL)->EnableWindow(FALSE);
	m_nContactVersion = 1;	
	m_c_AddressBook.SetFileVersion(m_nContactVersion);


	ResetAllColumns();
	m_cList.InsertColumn(0, _T("First Name"), LVCFMT_LEFT,80);
	m_cList.InsertColumn(1, _T("Last name"), LVCFMT_LEFT,120);	
	m_cList.InsertColumn(2, _T("Address"), LVCFMT_LEFT,160);	
	m_cList.InsertColumn(3, _T("Phone"), LVCFMT_LEFT,70);

	PopulateList();
}

void CSerAddressBookDlg::OnBnClickedRadioVersion2()
{
	GetDlgItem(IDC_EDIT_FIRSTNAME)->EnableWindow(TRUE);
	GetDlgItem(IDC_EDIT_LASTNAME)->EnableWindow(TRUE);
	GetDlgItem(IDC_EDIT_ADDRESS)->EnableWindow(TRUE);
	GetDlgItem(IDC_EDIT_PHONE)->EnableWindow(TRUE);
	GetDlgItem(IDC_EDIT_MOBILE_PHONE)->EnableWindow(TRUE);
	GetDlgItem(IDC_EDIT_EMAIL)->EnableWindow(TRUE);
	m_nContactVersion = 2;
	m_c_AddressBook.SetFileVersion(m_nContactVersion);

	ResetAllColumns();
	m_cList.InsertColumn(0, _T("First Name"), LVCFMT_LEFT,80);
	m_cList.InsertColumn(1, _T("Last name"), LVCFMT_LEFT,120);	
	m_cList.InsertColumn(2, _T("Address"), LVCFMT_LEFT,160);	
	m_cList.InsertColumn(3, _T("Phone"), LVCFMT_LEFT,70);
	m_cList.InsertColumn(4, _T("Mobile.Phone"), LVCFMT_LEFT,70);
	m_cList.InsertColumn(5, _T("E-mail"), LVCFMT_LEFT,100);

	PopulateList();
}

void CSerAddressBookDlg::ResetMembers()
{
	m_strFirstName		= _T("");
	m_strLastName		= _T("");
	m_strAddress		= _T("");
	m_strPhone			= _T("");
	m_strMobilePhone	= _T("");
	m_strEmail			= _T("");
	UpdateData(FALSE);
}


void CSerAddressBookDlg::OnBnClickedBtnSave()
{
	CString szFilters =   _T("SerAddressBook Data File V2 (*.sab2)|*.sab2| SerAddressBook Data File V1 (*.sab1)|*.sab1||");
	CFileDialog dlg(FALSE,_T("sab1"),NULL,OFN_HIDEREADONLY|OFN_OVERWRITEPROMPT, szFilters, NULL);

	UpdateData(TRUE);

	if(dlg.DoModal() == IDOK)
	{
		m_strFilePath = dlg.GetPathName();
		m_bResultExpected = false;

		CString sExt = dlg.GetFileExt();

		if (!sExt.CompareNoCase(_T("sab1")))
			m_c_AddressBook.SetFileVersion(1);
		else 
			if (!sExt.CompareNoCase(_T("sab2")))
				m_c_AddressBook.SetFileVersion(2);

		SaveDataContentToFile(m_strFilePath);
	}
		
	UpdateData(FALSE);
}

void CSerAddressBookDlg::OnBnClickedBtnLoad()
{
	CString szFilters =   _T("SerAddressBook Data File V2 (*.sab2)|*.sab2| SerAddressBook Data File V1 (*.sab1)|*.sab1||");
	CFileDialog dlg(TRUE,_T("sab1"),NULL,OFN_HIDEREADONLY|OFN_OVERWRITEPROMPT, szFilters,NULL);

	UpdateData(TRUE);
	if(dlg.DoModal() == IDOK)
	{
		m_strFilePath = dlg.GetPathName();

		LoadDataContentFromFile(m_strFilePath);
	}
	UpdateData(FALSE);
}

void CSerAddressBookDlg::OnBnClickedBtnAddDataToGrid()
{
	UpdateData(TRUE);
	int nCurrentItem = m_cList.GetItemCount() + 1;
	
	if (m_strFirstName == _T("") || (m_strLastName == _T("")))
	{
		AfxMessageBox(_T("Some of FirstName and LastName fields are empty! You cannot add to list this record."), MB_OK);
		return;
	}

	nCurrentItem = m_cList.InsertItem(nCurrentItem, m_strFirstName);
	m_cList.SetItemText(nCurrentItem, 1, m_strLastName);
	m_cList.SetItemText(nCurrentItem, 2, m_strAddress);
	m_cList.SetItemText(nCurrentItem, 3, m_strPhone);

	if (m_nContactVersion == 1)
	{
		// add a new contact to the book
		Contact newContact(m_strFirstName, m_strLastName, m_strAddress, m_strPhone);
		m_c_AddressBook.AddContact(newContact);
	}
	else if (m_nContactVersion == 2)
	{
		// set two more fields
		m_cList.SetItemText(nCurrentItem, 4, m_strMobilePhone);
		m_cList.SetItemText(nCurrentItem, 5, m_strEmail);

		// add a new contact to the book
		Contact newContact(m_strFirstName, m_strLastName, m_strAddress, m_strPhone, m_strMobilePhone, m_strEmail);
		m_c_AddressBook.AddContact(newContact);
	}
	
	ResetMembers();
}

void CSerAddressBookDlg::OnBnClickedBtnRemoveDataFromGrid()
{
	POSITION pos;

	pos = m_cList.GetFirstSelectedItemPosition();
	
	if (pos != NULL)
	{
		long nCurrentPos = (long)pos - 1;
		m_cList.DeleteItem(nCurrentPos);
	}
}


void CSerAddressBookDlg::SaveDataContentToFile(CString strSaveFile)
{
	CFile wFile(strSaveFile, CFile::modeCreate | CFile::modeWrite);

	// Create a storing archive
	CArchive arStore(&wFile, CArchive::store);
		m_c_AddressBook.Serialize(arStore);

	// Close the storing archive
	arStore.Close();

	PopulateList();
}

void CSerAddressBookDlg::LoadDataContentFromFile(CString strLoadedFile)
{
	CFile rFile(strLoadedFile, CFile::modeRead);

	// Create a loading archive
	CArchive arLoad(&rFile, CArchive::load);
	m_c_AddressBook.Serialize(arLoad);
	
	// Close the loading archive
	arLoad.Close();

	switch (m_c_AddressBook.GetFileVersion())
	{
		case 1:
			((CButton*)GetDlgItem(IDC_RADIO_VERSION_1))->SetCheck(BST_CHECKED);
			((CButton*)GetDlgItem(IDC_RADIO_VERSION_2))->SetCheck(BST_UNCHECKED);
			OnBnClickedRadioVersion1();
			break;
		case 2:
			((CButton*)GetDlgItem(IDC_RADIO_VERSION_1))->SetCheck(BST_UNCHECKED);
			((CButton*)GetDlgItem(IDC_RADIO_VERSION_2))->SetCheck(BST_CHECKED);
			OnBnClickedRadioVersion2();
			break;
		default:
			break;
	}

	// repopulate the list
	PopulateList();
}

void CSerAddressBookDlg::PopulateList()
{
	// delete all current members
	m_cList.DeleteAllItems();

	// get a reference to the contacts list
	const ContactList& contacts = m_c_AddressBook.GetContacts();

	// iterate over all contacts add add them to the list
	int nCurrentItem = 0;
	POSITION pos = contacts.GetHeadPosition();
	while(pos != NULL)
	{
		const Contact contact = contacts.GetNext(pos);

		nCurrentItem = m_cList.InsertItem(nCurrentItem, contact.GetFirstName());
		m_cList.SetItemText(nCurrentItem, 1, contact.GetLastName());
		m_cList.SetItemText(nCurrentItem, 2, contact.GetAddress());
		m_cList.SetItemText(nCurrentItem, 3, contact.GetPhoneNumber());

		
		switch(m_c_AddressBook.GetFileVersion())
		{
		case 1:
			break;
		case 2:
			m_cList.SetItemText(nCurrentItem, 4, contact.GetMobileNumber());
			m_cList.SetItemText(nCurrentItem, 5, contact.GetEmail());
			break;
		}
	}
}

void CSerAddressBookDlg::OnBnClickedBtnCleanTheList()
{
	if (m_cList.GetItemCount() > 0)
	{
		m_cList.DeleteAllItems();
	}

	m_c_AddressBook.m_cContactsList.RemoveAll();
	PopulateList();
}

void CSerAddressBookDlg::OnBnClickedBtnExit()
{
	PostMessage(WM_CLOSE);
}

void CSerAddressBookDlg::ResetAllColumns(void)
{
	int nColumnCount = m_cList.GetHeaderCtrl()->GetItemCount();
	for (int i=0; i < nColumnCount; i++)
		m_cList.DeleteColumn(0); 
}
